package com.bbu.PV;
import java.io.*;
import java.util.Random;
public class Consumer implements Runnable{
	FileOutputStream foc;
	public void init(FileOutputStream f) {
		this.foc=f;
	}
	public void run() {
		try {
			
			/*将运行的详细信息写入文件，便于查看运行的具体流程及信息。*/
		//	FileOutputStream foc=new FileOutputStream("proginfo.txt");
			
			while(true) {   //消费者不断从缓冲区取数据
				
				int pro;  //临时变量，存放取出的数据
				
				/*P操作，检查缓冲区是否有数据*/
				while(Buffer.full<=0) {
					foc.write(("\nblockConsumer,empty="+Buffer.empty+",full="+Buffer.full).getBytes());  //缓冲区无数据，阻塞
					foc.flush();
					continue;
				}
				foc.write(("\nrunConsumer,empty="+Buffer.empty+",full="+Buffer.full).getBytes());//缓冲区有数据，进行下一步
				
				
				/*P操作，实现对缓冲区的互斥*/
				while(Buffer.mutex<=0) {
					//System.out.println("wait");
					foc.write(("\nblockConsumer,mutex="+Buffer.mutex).getBytes()); //缓冲区被占用，阻塞
					foc.flush();
					continue;
				}
				foc.write(("\nrunConsumer,mutex="+Buffer.mutex).getBytes());  //缓冲区此时为空闲，生消费者占用，进行下一步
				
				
				Buffer.full--;   //数据区减一，实现消费者之间的互斥
				Buffer.mutex--;  //缓冲区状态转为被占用
				
				
				/*取出数据*/
				pro=Buffer.get();
				
				System.out.println("get("+pro+")缓冲区剩余"+Buffer.full+"个数");  //打印
				foc.write(("\nget("+pro+")缓冲区剩余"+Buffer.full).getBytes());   //写入文件，便于查看
				foc.flush();
				
				
				/*V操作,释放缓冲区*/
				Buffer.mutex++;
				
				/*V操作，空区加一，实现生产者与消费者的共享*/
				Buffer.empty++;
				
				
				/*消费者的消费间隔*/
				try {
					Thread.sleep(new Random(System.currentTimeMillis()).nextInt(5000));
				}
				catch(Exception e) {
					e.printStackTrace();
				}
				finally {}
				//循环结束
			}
			
			
		}catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
