package com.bbu.PV;
import java.util.Random;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
public class Producer implements Runnable{
	
	FileOutputStream fop;
	public void init(FileOutputStream f) {
		this.fop=f;
	}
	public void run(){
		try {
			
			/*将运行的详细信息写入文件，便于查看运行的具体流程及信息。*/
			FileOutputStream fop =new FileOutputStream("proginfo.txt");  
		
			while(true) {    //生产者不断的生产数据
				
				/*生产数据模块*/
				Random random= new Random(System.currentTimeMillis());
				int pro=random.nextInt(100);
				System.out.println("生产了一个数："+(pro));
				fop.write(("\n生产了一个数："+pro).getBytes());
				
				
				/*P操作，检查是否剩余空缓冲区放入数据*/
				while(Buffer.empty<=0) {
					fop.write(("\nblockProducer,empty="+Buffer.empty+",full="+Buffer.full).getBytes());  //无空区，阻塞
					fop.flush();
					continue;
				}
				fop.write(("\nrunProducer,empty="+Buffer.empty+",full="+Buffer.full).getBytes());//有空区，进行下一步
				
				
				
				/*P操作，实现对缓冲区的互斥*/
				while(Buffer.mutex<=0) {
					//System.out.println("wait");
					fop.write(("\nblockProducer,mutex="+Buffer.mutex).getBytes()); //缓冲区被占用，阻塞
					fop.flush();
					continue;
				}
				fop.write(("\nrunProducer,mutex="+Buffer.mutex).getBytes());  //缓冲区此时为空闲，生产者占用，进行下一步
				
				
				Buffer.empty--;   //空区减一，实现生产者之间的互斥
				Buffer.mutex--;   //缓冲区状态转为被占用
				
				/*放入数据*/
				Buffer.put(pro);
				System.out.println("put("+pro+")缓冲区已有"+(Buffer.full+1)+"个数");  //打印
				fop.write(("\nput("+pro+")缓冲区已有"+(Buffer.full+1)+"个数").getBytes());  //写入文件，便于查看
				fop.flush();
				
				
				/*V操作,释放缓冲区*/
				Buffer.mutex++;
				
				/*V操作，数据区加一，实现生产者与消费者的共享*/
				Buffer.full++;
				
				
				/*生产者的生产间隔*/
				try{
					
					Thread.sleep(new Random(System.currentTimeMillis()).nextInt(4000));  //生产者的休息时间为随机
				}
				catch(Exception e) {
					e.printStackTrace();
				}
				//finally {}
			}   //循环结束
			
			
		}  
		catch(FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
